//+------------------------------------------------------------------+
//|                                     Waddah Attar Daily Fibo Proj |
//|                                   Copyright  2007, Waddah Attar |
//|                             Waddah Attar waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Waddah Attar waddahattar@hotmail.com"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Orchid 
#property indicator_color2 Orchid
#property indicator_color3 Violet 
#property indicator_color4 Violet
#property indicator_color5 Violet
#property indicator_color6 Violet
#property indicator_color7 Violet

extern bool ShowPercent=true;
/*
STYLE_SOLID 0 The pen is solid. 
STYLE_DASH 1 The pen is dashed. 
STYLE_DOT 2 The pen is dotted. 
STYLE_DASHDOT 3 The pen has alternating dashes and dots. 
STYLE_DASHDOTDOT 4 The pen has alternating dashes and double dots. 
*/
extern int myStyle  = 2 ;


//---- buffers
double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];

//----
int myPeriod = PERIOD_D1;


//----
double Q,H,L,F;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, P4Buffer);

//----
   SetIndexStyle(0, DRAW_LINE, myStyle , 1);
   SetIndexStyle(1, DRAW_LINE, myStyle, 1);  //  STYLE_SOLID
   SetIndexStyle(2, DRAW_LINE, myStyle, 1);
   SetIndexStyle(3, DRAW_LINE, myStyle, 1);

//----
   Comment("Waddah Attar Daily Fibo Proj");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("DayFP1");
   ObjectDelete("DayFP2");
   ObjectDelete("DayFP3");
   ObjectDelete("DayFP4");
   ObjectDelete("DayFP5");
   ObjectDelete("DayFP6");
   ObjectDelete("DayFP7");
   ObjectDelete("txtDayFP1");
   ObjectDelete("txtDayFP2");
   ObjectDelete("txtDayFP3");
   ObjectDelete("txtDayFP4");
   ObjectDelete("txtDayFP5");
   ObjectDelete("txtDayFP6");
   ObjectDelete("txtDayFP7");
   ObjectDelete("DPercent");
   ObjectDelete("DPrice");
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {
       dayi = iBarShift(Symbol(), myPeriod, Time[i], false);
       H=iHigh(Symbol(), myPeriod,dayi + 1);
       L=iLow(Symbol(), myPeriod,dayi + 1);
       Q = (H-L);
       //----
       P1Buffer[i] = H+(Q*0.618);
       SetPrice("DayFP1", Time[i], P1Buffer[i], indicator_color1);
       SetText("txtDayFP1", "+61.8% Proj              ", Time[i], P1Buffer[i], indicator_color1);
       //----
       P2Buffer[i] = H+(Q*0.382);
       SetPrice("DayFP2", Time[i], P2Buffer[i], indicator_color2);
       SetText("txtDayFP2", "+38.2% Proj              ", Time[i], P2Buffer[i], indicator_color2);
       //----
       P3Buffer[i] = L-(Q*0.382);
       SetPrice("DayFP3", Time[i], P3Buffer[i], indicator_color3);
       SetText("txtDayFP3", "-38.2% Proj              ", Time[i],P3Buffer[i], indicator_color3);
       //----
       P4Buffer[i] = L-(Q*0.618);
       SetPrice("DayFP4", Time[i], P4Buffer[i], indicator_color4);
       SetText("txtDayFP4", "-61.8% Proj              ", Time[i], P4Buffer[i], indicator_color4);
       //----
      
    }
    
    F=(Bid-L)/Q*100;
    
    if (ShowPercent==true)
    {
//    SetLabel("DPrice","Price ="+DoubleToStr(Bid,Digits),1,30,"Simplified Arabic Fixed",20,0,indicator_color1);
//    SetLabel("DPercent","D Fibo="+DoubleToStr(F,2)+"%",1,92,"Simplified Arabic Fixed",20,0,indicator_color1);
    }
    else
    {
      ObjectDelete("DPercent");
      ObjectDelete("DPrice");
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetPrice(string name, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, Tm, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetText(string name, string txt, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_TEXT, 0, Tm, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     } 
  }
  
void SetLabel(string name,string txt,int x,int y,string font,int size,int angle,color clr)
  {
   int idx=0;
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_LABEL, idx, 0, 0);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSet(name, OBJPROP_CORNER, 2);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     }
   else
     {
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     } 
  }

//+------------------------------------------------------------------+