//+------------------------------------------------------------------+
//|                                         Waddah Attar Daily Fibo |
//|                                   Copyright  2007, Waddah Attar |
//|                             Waddah Attar waddahattar@hotmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Waddah Attar waddahattar@hotmail.com"
#property link      "waddahattar@hotmail.com"
//----
#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 Orchid 
#property indicator_color2 Orchid
#property indicator_color3 Violet
#property indicator_color4 Violet
#property indicator_color5 Violet
#property indicator_color6 Violet
#property indicator_color7 Violet

extern bool ShowPercent=true;
/*
STYLE_SOLID 0 The pen is solid. 
STYLE_DASH 1 The pen is dashed. 
STYLE_DOT 2 The pen is dotted. 
STYLE_DASHDOT 3 The pen has alternating dashes and dots. 
STYLE_DASHDOTDOT 4 The pen has alternating dashes and double dots. 
*/
extern int myStyle  = 2 ;


//---- buffers
double P1Buffer[];
double P2Buffer[];
double P3Buffer[];
double P4Buffer[];
double P5Buffer[];
double P6Buffer[];
double P7Buffer[];
//----
int myPeriod = PERIOD_D1;


//----
double Q,H,L,F;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   SetIndexBuffer(0, P1Buffer);
   SetIndexBuffer(1, P2Buffer);
   SetIndexBuffer(2, P3Buffer);
   SetIndexBuffer(3, P4Buffer);
   SetIndexBuffer(4, P5Buffer);
   SetIndexBuffer(5, P6Buffer);
   SetIndexBuffer(6, P7Buffer);
//----
   SetIndexStyle(0, DRAW_LINE, myStyle , 1);
   SetIndexStyle(1, DRAW_LINE, myStyle, 1);  //  STYLE_SOLID
   SetIndexStyle(2, DRAW_LINE, myStyle, 1);
   SetIndexStyle(3, DRAW_LINE, myStyle, 1);
   SetIndexStyle(4, DRAW_LINE, myStyle, 1);
   SetIndexStyle(5, DRAW_LINE, myStyle, 1);
   SetIndexStyle(6, DRAW_LINE, myStyle, 1);
//----
   Comment("Waddah Attar Daily Fibo");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete("DayF1");
   ObjectDelete("DayF2");
   ObjectDelete("DayF3");
   ObjectDelete("DayF4");
   ObjectDelete("DayF5");
   ObjectDelete("DayF6");
   ObjectDelete("DayF7");
   ObjectDelete("txtDayF1");
   ObjectDelete("txtDayF2");
   ObjectDelete("txtDayF3");
   ObjectDelete("txtDayF4");
   ObjectDelete("txtDayF5");
   ObjectDelete("txtDayF6");
   ObjectDelete("txtDayF7");
   ObjectDelete("DPercent");
   ObjectDelete("DPrice");
   Comment("");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)
     {
       dayi = iBarShift(Symbol(), myPeriod, Time[i], false);
       H=iHigh(Symbol(), myPeriod,dayi + 1);
       L=iLow(Symbol(), myPeriod,dayi + 1);
       Q = (H-L);
       //----
       P1Buffer[i] = H;
       SetPrice("DayF1", Time[i], H, indicator_color1);
       SetText("txtDayF1", "Daily High                   ", Time[i], H, indicator_color1);
       //----
       P2Buffer[i] = L;
       SetPrice("DayF2", Time[i], L, indicator_color2);
       SetText("txtDayF2", "Daily Low                   ", Time[i], L, indicator_color2);
       //----
       P3Buffer[i] = L+(Q*0.236);
       SetPrice("DayF3", Time[i], L+(Q*0.236), indicator_color3);
       SetText("txtDayF3", "Daily 23.6%                   ", Time[i], L+(Q*0.236), indicator_color3);
       //----
       P4Buffer[i] = L+(Q*0.382);
       SetPrice("DayF4", Time[i], L+(Q*0.382), indicator_color4);
       SetText("txtDayF4", "Daily 38.2%                   ", Time[i], L+(Q*0.382), indicator_color4);
       //----
       P5Buffer[i] = L+(Q*0.50);
       SetPrice("DayF5", Time[i], L+(Q*0.50), indicator_color5);
       SetText("txtDayF5", "Daily 50%                   ", Time[i], L+(Q*0.50), indicator_color5);
       //----
       P6Buffer[i] = L+(Q*0.618);
       SetPrice("DayF6", Time[i], L+(Q*0.618), indicator_color6);
       SetText("txtDayF6", "Daily 61.8%                   ", Time[i], L+(Q*0.618), indicator_color6);
       //----
       P7Buffer[i] = L+(Q*0.764);
       SetPrice("DayF7", Time[i], L+(Q*0.764), indicator_color7);
       SetText("txtDayF7", "Daily 76.4%                   ", Time[i], L+(Q*0.764), indicator_color7);

    }
    
    F=(Bid-L)/Q*100;
    
    if (ShowPercent==true)
    {
//    SetLabel("DPrice","Price ="+DoubleToStr(Bid,Digits),1,30,"Simplified Arabic Fixed",20,0,indicator_color1);
    SetLabel("DPercent","D Fibo="+DoubleToStr(F,2)+"%",1,92,"Simplified Arabic Fixed",20,0,indicator_color1);
    }
    else
    {
      ObjectDelete("DPercent");
      ObjectDelete("DPrice");
    }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetPrice(string name, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, Tm, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSet(name, OBJPROP_COLOR, clr);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SetText(string name, string txt, datetime Tm, double Prc, color clr)
  {
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_TEXT, 0, Tm, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, Tm);
       ObjectSet(name, OBJPROP_PRICE1, Prc);
       ObjectSetText(name, txt, 10, "Times New Roman", clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
     } 
  }
  
void SetLabel(string name,string txt,int x,int y,string font,int size,int angle,color clr)
  {
   int idx=0;
   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_LABEL, idx, 0, 0);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSet(name, OBJPROP_CORNER, 2);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     }
   else
     {
       ObjectSet(name, OBJPROP_XDISTANCE, x);
       ObjectSet(name, OBJPROP_YDISTANCE, y);
       ObjectSetText(name, txt, size, font, clr);
       ObjectSet(name, OBJPROP_CORNER, 2);
       ObjectSet(name, OBJPROP_ANGLE, angle);
     } 
  }
  
//+------------------------------------------------------------------+